/***********************************************************************
 * Linotte                                                             *
 * Version release date : September 01, 2006                           *
 * Author : Mounes Ronan ronan.mounes@amstrad.eu                       *
 *                                                                     *
 *     http://langagelinotte.free.fr                                   *
 *                                                                     *
 * This code is released under the GNU GPL license, version 2 or       *
 * later, for educational and non-commercial purposes only.            *
 * If any part of the code is to be included in a commercial           *
 * software, please contact us first for a clearance at                *
 *   ronan.mounes@amstrad.eu                                           *
 *                                                                     *
 *   This notice must remain intact in all copies of this code.        *
 *   This code is distributed WITHOUT ANY WARRANTY OF ANY KIND.        *
 *   The GNU GPL license can be found at :                             *
 *           http://www.gnu.org/copyleft/gpl.html                      *
 *                                                                     *
 ***********************************************************************/

package org.linotte.moteur.xml.actions;

import org.linotte.moteur.entites.Livre;
import org.linotte.moteur.entites.Paragraphe;
import org.linotte.moteur.exception.ErreurException;
import org.linotte.moteur.outils.Chaine;
import org.linotte.moteur.xml.alize.kernel.Action;
import org.linotte.moteur.xml.alize.kernel.Job;
import org.linotte.moteur.xml.alize.kernel.JobContext;
import org.linotte.moteur.xml.analyse.ItemXML;
import org.linotte.moteur.xml.appels.CalqueParagraphe;

public class EtatParagraphe extends Action {

	public EtatParagraphe() {
		super();
	}

	@Override
	public String clef() {
		return "creation paragraphe";
	}

	@Override
	public ETAT analyse(String param, Job job, ItemXML[] valeurs, String[] annotations) throws ErreurException {
		JobContext jobContext = (JobContext) job.getContext();

		Livre livre = jobContext.getLivre();
		String clef = "§";
		if (valeurs.length != 0)
			//throw new ErreurException(Constantes.IMPOSSIBLE_LIRE_LIVRE);
			/*String*/clef = valeurs[0].toString();

		//VERSION2.2, on ne clone plus le paragraphe
		CalqueParagraphe calqueParagraphe = new CalqueParagraphe();
		livre.getKernelStack().ajouterAppel(calqueParagraphe);
		Paragraphe para = new Paragraphe(clef);
		livre.setParagraphe(para);
		// Linotte 2.1 :
		if (jobContext.getPrototype() != null) {
			// On force l'ajout de l'acteur moi qui représente
			livre.getParagraphe().addDoublure("moi", jobContext.getPrototype());
			calqueParagraphe.addActeurLocalDoublure(new Chaine("moi"), jobContext.getPrototype());
		}

		return ETAT.PAS_DE_CHANGEMENT;
	}

}
