package org.linotte.moteur.xml.appels;

import org.linotte.moteur.entites.Acteur;
import org.linotte.moteur.entites.Paragraphe;
import org.linotte.moteur.xml.alize.kernel.processus.Processus;

public class Fonction implements Appel {

	private Processus processusRetour;

	private Paragraphe paragraphe;

	private Boucle boucle;

	private Acteur[] doublure = null;

	public Fonction(Boucle boucle, Processus processus, Paragraphe paragraphe) {
		super();
		this.boucle = boucle;
		this.paragraphe = paragraphe;
		this.processusRetour = processus;
	}

	public Fonction(Processus processus, Paragraphe paragraphe) {
		super();
		this.processusRetour = processus;
		this.paragraphe = paragraphe;
	}

	public Fonction(Processus processus, Paragraphe paragraphe, Acteur[] acteurs) {
		super();
		this.processusRetour = processus;
		this.paragraphe = paragraphe;
		this.doublure = acteurs;
	}

	public Fonction(Boucle boucle, Processus processus, Paragraphe paragraphe, Acteur[] acteurs) {
		this.boucle = boucle;
		this.paragraphe = paragraphe;
		this.processusRetour = processus;
		this.doublure = acteurs;
	}

	public Paragraphe getParagraphe() {
		return paragraphe;
	}

	public Boucle getBoucle() {
		return boucle;
	}

	public Acteur getDoublure(int i) {
		if (doublure == null)
			return null;
		if (i >= doublure.length)
			return null;
		else
			return doublure[i];
	}

	@Override
	public String toString() {
		return "Fonction";
	}

	public Processus getProcessusRetour() {
		return processusRetour;
	}
	
	@Override
	public APPEL getType() {
		return APPEL.FONCTION;
	}

}